import 'package:flutter_custom_toolbox/flutter_toolbox.dart';

import 'package:twister/config/default_game_settings.dart';

class GameSettings {
  final String timerValue;

  GameSettings({
    required this.timerValue,
  });

  static String getTimerValueFromUnsafe(String timerValue) {
    if (DefaultGameSettings.allowedTimerValues.contains(timerValue)) {
      return timerValue;
    }

    return DefaultGameSettings.defaultTimerValue;
  }

  factory GameSettings.createDefault() {
    return GameSettings(
      timerValue: DefaultGameSettings.defaultTimerValue,
    );
  }

  void dump() {
    printlog('$GameSettings:');
    printlog('  ${DefaultGameSettings.parameterCodeTimerValue}: $timerValue');
    printlog('');
  }

  @override
  String toString() {
    return '$GameSettings(${toJson()})';
  }

  Map<String, dynamic>? toJson() {
    return <String, dynamic>{
      DefaultGameSettings.parameterCodeTimerValue: timerValue,
    };
  }
}
